package com.smppw.analysis.domain.service;

import com.smppw.analysis.domain.dataobject.FundArchivesInfoDO;
import com.smppw.analysis.domain.dataobject.ManualFundNoticeInfoDO;
import com.smppw.analysis.domain.dataobject.FundSimilarDo;
import com.smppw.analysis.domain.dataobject.MonetaryFundProfitDO;
import com.smppw.analysis.domain.dto.info.FundSimilarParams;
import com.smppw.common.pojo.enums.Frequency;
import com.smppw.common.pojo.enums.Indicator;

import java.util.List;
import java.util.Map;

/**
 * @author wangzaijun
 * @date 2023/8/3 15:42
 * @description 基础信息服务
 */
public interface BaseInfoService {
    String getLatestRankRat();

    String getLatestRankRat(String refId);

    String getSecType(String secId);

    Map<String, List<String>> getTypeSecMap(List<String> secIdList);

    Map<String, String> querySecsType(List<String> secIdList);

    Map<String, String> querySecName(List<String> allSecIdList);

    Frequency getNavFrequency(String secId);

    List<MonetaryFundProfitDO> queryMonetaryFund(String fundId);

    List<Map<String, Object>> getFundRank(String rankDate, String fundId, List<String> indexIds, Indicator indicator);

    List<FundSimilarDo> getFundSimilarList(FundSimilarParams params);

    /**
     * 获取公募基金的公告信息
     *
     * @param fundId   公募基金id
     * @param typeList 信息类别list
     * @param title    信息标题
     * @return 公告信息
     */
    List<ManualFundNoticeInfoDO> queryFundAnnounce(String fundId, List<String> typeList, String title);

    /**
     * 获取公募基金投资类信息说明
     *
     * @param fundId 基金id
     * @return 公募基金投资类信息说明
     */
    FundArchivesInfoDO queryFundArchives(String fundId);

}
